#ifndef MP_CMPLAYER_H
#define MP_CMPLAYER_H

#ifdef __cplusplus
extern "C" {
#endif

#include <mpvcore/mp_core.h>

enum mp_error_type {MPERROR_NONE, MPERROR_USER_INTERRUPTED, MPERROR_OPEN_FILE, MPERROR_OPEN_DEMUXER, MPERROR_OPEN_STREAM, MPERROR_NO_STREAM, MPERROR_INIT_VIDEO_FILTER, MPERROR_INIT_AUDIO_FILTER};

typedef int(*player_message_filter)(struct MPContext *, int, int, const char *);

typedef int(*player_command_filter)(struct MPContext *, struct mp_cmd *);
void mp_register_player_command_filter(player_command_filter filter);

typedef int(*player_event_filter)(struct MPContext *);
void mp_register_player_event_filter(player_event_filter filter);

struct MPContext *create_player(int argc, char **argv);
void destroy_player(struct MPContext *mpctx);
void idle_player(struct MPContext *mpctx);

enum mp_error_type prepare_playback(struct MPContext *mpctx);
void clean_up_playback(struct MPContext *mpctx);
void run_playloop(struct MPContext *mpctx);

#ifdef __cplusplus
}
#endif

#endif
